// LiveHatching A^C`GtFNgvO@openCV
// program T.Ogura
// Data 2008.12.16 EMail:t-ogura@t3.rim.or.jp
//
// LvOAviUtlvOC

#include <windows.h>
#include "cv.h"
#include "highgui.h"
#include <stdio.h>		// printf() / scanf()
#include "filter.h"

#ifndef _DEBUG
#pragma comment(lib,"cv.lib")
#pragma comment(lib,"cvaux.lib")
#pragma comment(lib,"cxcore.lib")
#pragma comment(lib,"highgui.lib")
#else
#pragma comment(lib,"cvd.lib")
#pragma comment(lib,"cvauxd.lib")
#pragma comment(lib,"cxcored.lib")
#pragma comment(lib,"highguid.lib")
#endif

#define YC2R(Y,Cb,Cr) (Y + 1.402*Cr)
#define YC2G(Y,Cb,Cr) (Y - 0.344*Cb - 0.714*Cr)
#define YC2B(Y,Cb,Cr) (Y + 1.772*Cb)
#define RGB2Y(R,G,B) (0.299*R + 0.587*G + 0.114*B)
#define RGB2CB(R,G,B) (-0.169*R - 0.331*G + 0.500*B)
#define RGB2CR(R,G,B) (0.500*R - 0.419*G - 0.081*B)

// [min, max] ͈̔͂ɖOa
template <class T>
T Saturate(T v, T min, T max) {
	if (v < min) {
		return min;
	} else if (v > max) {
		return max;
	}
	return v;
}

class BufToCv {
public:
	static const double MLT;
	static const double DIV;
	
	template <class T>
	static T to(double v) {
		return (T)v;
	}

	template <>
	static unsigned char to<unsigned char>(double v) {
		return (unsigned char)Saturate(v/16.0, 0.0, 255.0);
	}

	template <>
	static float to<float>(double v) {
		return (float)(v * DIV);
	}

	template <>
	static double to<double>(double v) {
		return v * DIV;
	}

	template <class T>
	static double from(T v) {
		return v;
	}

	template <>
	static double from<unsigned char>(unsigned char v) {
		return v * 16;
	}

	template <>
	static double from<float>(float v) {
		return v * MLT;
	}

	template <>
	static double from<double>(double v) {
		return v * MLT;
	}
};

const double BufToCv::MLT = 4096.0;
const double BufToCv::DIV = 1 / BufToCv::MLT;

template <class T>
void CopyBufToCvBGRImg(
		PIXEL_YC *buf, IplImage *img,
		int x0, int y0, int w, int h, int x1, int y1, int mw, int mh
){
	int src,ix0,iy0,ix1,iy1;

#pragma omp parallel for private(iy0,ix0,iy1,ix1,src)
	for(iy0 = y0; iy0 < y0 + h; iy0++) {
		iy1 = y1 + (iy0-y0);
		src = x0 + iy0 * mw;
		for(ix0 = x0,ix1 = x1; ix0 < x0 + w; ix0++) {
			CV_IMAGE_ELEM(img, T, iy1, ix1*3+0) = BufToCv::to<T>(YC2B(buf[src].y, buf[src].cb, buf[src].cr));
			CV_IMAGE_ELEM(img, T, iy1, ix1*3+1) = BufToCv::to<T>(YC2G(buf[src].y, buf[src].cb, buf[src].cr));
			CV_IMAGE_ELEM(img, T, iy1, ix1*3+2) = BufToCv::to<T>(YC2R(buf[src].y, buf[src].cb, buf[src].cr));
			src++;
			ix1++;
		}
	}
}

template <class T>
void CopyCvBGRImgToBuf(
		IplImage *img, PIXEL_YC *buf, 
		int x0, int y0, int w, int h, int x1, int y1, int mw, int mh
){
	int dst,ix0,iy0,ix1,iy1;
	PIXEL_YC yc;

#pragma omp parallel for private(iy0,ix0,iy1,ix1,dst,yc)
	for(iy0 = y0; iy0 < y0 + h; iy0++) {
		iy1 = y1 + (iy0-y0);
		dst = x1 + iy1 * mw;
		for(ix0 = x0,ix1 = x1; ix0 < x0 + w; ix0++) {
			double r,g,b;
			b = BufToCv::from<T>(CV_IMAGE_ELEM(img, T, iy0, ix0*3+0));
			g = BufToCv::from<T>(CV_IMAGE_ELEM(img, T, iy0, ix0*3+1));
			r = BufToCv::from<T>(CV_IMAGE_ELEM(img, T, iy0, ix0*3+2));
			yc.y =  (short)RGB2Y( r, g, b);
			yc.cb = (short)RGB2CB(r, g, b);
			yc.cr = (short)RGB2CR(r, g, b);
			buf[dst] = yc;
			dst++;
			ix1++;
		}
	}
}

namespace param{
	int X = 5;			// LineStep 傫ƃKNKN
	int Y = 54;			// oo@傫Ɠ͑a
	int Z = 0;			// LineLength }CiXœ_ɁAvXŖ[I[o[
	int lineWidth = 1;	// ̑
	int lineNoise = 15;	// ߐڃsNZƂ̔r臒lB0ȏɂƐr؂
	double DARK = 1.0;	// GbW̐F̋Px

	int VFlag = 0;		// K}␳݂ȁH
	int hatchingType = 0;     // 0..normal 1..inverse 2..white-base
	const int nPattern = 7;   // nb`Op^[
	int drawMode = 3;
	int drawFps = 0;
	int patternOffset = 0;
	IplImage *hatching[nPattern];
}
using namespace param;

typedef struct PointTable{
	CvPoint p;
	CvScalar color;
} POINTTABLE;

const int MAXPOINT = 100000;
POINTTABLE pointTable[MAXPOINT];

// RGB̍v
double colorLen(CvScalar &x, CvScalar &y)
{
	double sum = 0;
	for(int i=0;i<3;i++){
		sum += abs(x.val[i] - y.val[i]);
	}
	return sum;
}

// image̍WʒuJ[
CvScalar getColor(IplImage* image, int x, int y)
{
	int index = y * image->widthStep + x * image->nChannels;
	unsigned char *data =  (unsigned char *)image->imageData;
	return CV_RGB(data[index+2],data[index+1],data[index+0]);
}

// WC[WOɂ\̂ꍇp
CvScalar getColorCheck(IplImage* image, int x, int y)
{
	if (x<0) x = 0;
	if (y<0) y = 0;
	if (x>=image->width) x = image->width-1;
	if (y>=image->height) y = image->height-1;
	return getColor(image, x, y);
}

void divScaler(CvScalar &s, double d)
{
	s.val[0] /= d;
	s.val[1] /= d;
	s.val[2] /= d;
	s.val[3] /= d;
}
void mulScaler(CvScalar &s, double d)
{
	s.val[0] *= d;
	s.val[1] *= d;
	s.val[2] *= d;
	s.val[3] *= d;
}

//ߐڃsNZƂ̐F̍̍ől臒lr

int checkPoint(IplImage *image, int x, int y, double th)
{
	static struct { int x,y; } map[4] = { { 1,0 }, {-1,0}, { 0,1}, { 0,-1} };
	CvScalar color = getColor(image, x,y);
	for(int i = 0;i<4; i++){
		if (colorLen(color, getColorCheck(image, x+map[i].x, y + map[i].y)) > th) return 1;
	}
	return 0;
}
int setPoint(int index, CvPoint *point, CvScalar &color)
{
	if (index >= MAXPOINT) return 0;
	pointTable[index].p = *point;
	pointTable[index].color.val[0] = color.val[0];
	pointTable[index].color.val[1] = color.val[1];
	pointTable[index].color.val[2] = color.val[2];
	pointTable[index].color.val[3] = color.val[3];
	return 1;		
}
float clip(float x, float min, float max)
{
	if (x>max) return max;
	if (x<min) return min;
	return x;
}
// inputImageAbaseɍ plane 0,1,2:H,S,V 3:GrayScale̎
void drawEdge(IplImage* image,IplImage* base,int plane = 2)
{
	static IplImage *hsv =			cvCreateImage (cvGetSize (image), IPL_DEPTH_8U, 3);  
	static IplImage *grayImage=	cvCreateImage (cvGetSize (image), IPL_DEPTH_8U, 1);
	static IplImage *binaryImage=	cvCreateImage (cvGetSize (image), IPL_DEPTH_8U, 1);

	CvSize isize = cvGetSize(image);
	CvSize hsize = cvGetSize(hsv);
	if (isize.width != hsize.width || isize.height != hsize.height) {
		cvReleaseImage(&hsv);
		cvReleaseImage(&grayImage);
		cvReleaseImage(&binaryImage);
		hsv			= cvCreateImage(isize, IPL_DEPTH_8U, 3);
		grayImage   = cvCreateImage(isize, IPL_DEPTH_8U, 1);
		binaryImage = cvCreateImage(isize, IPL_DEPTH_8U, 1);
	}

	static CvMemStorage *memStorage0 =cvCreateMemStorage(0); 
	CvSeq *contourSeq0 = NULL;

	int height    = image->height;
	int width     = image->width;
	int step      = image->widthStep;
	int channels  = image->nChannels;
	uchar *data      = (uchar *)image->imageData;

	if (plane <3){
		cvCvtColor(image,hsv,CV_BGR2HSV);				// HSVplane搶̌ɂ
		for(int i=0;i<height*width;++i) grayImage->imageData[i] = hsv->imageData[i*3+plane];
	}else{
		cvCvtColor (image, grayImage, CV_BGR2GRAY);		// O[C[W搶̌ɂ
	}

	IplImage *target=base;					// ރ^[QbgC[W


	for(int x=20;x<240;x+=Y){
		cvThreshold( grayImage, binaryImage, x, 255, CV_THRESH_BINARY );	// x ̒lɂQl֊s𒊏o
		contourSeq0 = 0;
		cvFindContours(binaryImage, memStorage0, &contourSeq0,sizeof(CvContour), CV_RETR_LIST, CV_CHAIN_APPROX_NONE, cvPoint(0,0)); // ֊sT
		
		if (lineNoise>0){ // sAC̏ꍇ
			for(; contourSeq0 != 0; contourSeq0 = contourSeq0->h_next) 
			{
				CvPoint *p;
				if (contourSeq0->total<X*5) continue;		// 5p`ȉׂ͔̍̂r
				int index = 0;
				for( int i=0; i<contourSeq0->total; i+=X )
				{
					p = CV_GET_SEQ_ELEM(CvPoint, contourSeq0, i);				// _̏ꏊƐFo^
					CvScalar color = getColor(image,p->x, p->y);
					mulScaler(color,DARK);										// PxC
					color.val[3] = checkPoint(image, p->x, p->y, lineNoise);	// L_ǂߐڃsNZ画f[3]֊i[
					setPoint(index,p,color);									// pointTable֕ۑ
					index++;
					if (index > MAXPOINT){
						printf("INDEX ERROR\n"); 
						index = 0;
					}
				}
				// TAȉ̗L_͖ iPending:j
				for(int i=0;i<index;i++){
					int p1 = i;
					int p2,p3,p4,p0;
					if (pointTable[p1].color.val[3]){
						p2 = (p1+1)%index;
						p3 = (p1+2)%index;
						p4 = (p1+3)%index;
						p0 = (p1-1+index)%index;
						if (pointTable[p0].color.val[3]) continue;
						if (!pointTable[p2].color.val[3] ||
							!pointTable[p3].color.val[3] ||
							!pointTable[p4].color.val[3] ){						
							pointTable[p1].color.val[3] = 0;
						}
					}
				}
				// ڑꂽL_`
				for(int i=0;i<index;i++){
					int p1 = i;
					int p2 = (i+1)%index;// if (p2==index) p2 = 0;
					if (pointTable[p1].color.val[3] && pointTable[p2].color.val[3])
					{
						CvScalar c = pointTable[p1].color;
						mulScaler(c,DARK);
						cvLine(target,pointTable[p1].p,pointTable[p2].p,c,lineWidth,CV_AA );
					}
				}
			}
		}else{
			// S`ꍇ
			for(; contourSeq0 != 0; contourSeq0 = contourSeq0->h_next) 
			{

				CvPoint *p1 = 0;
				CvPoint *p2;

				if (contourSeq0->total<X*5) continue;		

				for(int i=0; i<contourSeq0->total; i+=X ){
					p1 = CV_GET_SEQ_ELEM(CvPoint, contourSeq0, (i)%contourSeq0->total);//n_
					p2 = CV_GET_SEQ_ELEM(CvPoint, contourSeq0, (i+X+Z)%contourSeq0->total);// I_
					CvScalar color = getColor(image,p1->x, p1->y);
					mulScaler(color,DARK);
					cvLine(target,*p1,*p2,color,lineWidth,CV_AA );
				}
			}
		}
	}
	cvClearMemStorage(memStorage0);
}
// HatchingGtFNg
int drawHatching(IplImage *frame, IplImage *base)
{
	static IplImage *hsv = cvCreateImage (cvGetSize (frame), IPL_DEPTH_8U, 3);  

	CvSize fsize = cvGetSize(frame);
	CvSize hsize = cvGetSize(hsv);
	if (fsize.width != hsize.width || fsize.height != hsize.height) {
		cvReleaseImage(&hsv);
		hsv = cvCreateImage(fsize, IPL_DEPTH_8U, 3);
	}

	cvCvtColor(frame,hsv,CV_BGR2HSV);
	int hwidth = hatching[0]->width;
	int hheight = hatching[0]->height;
	int rx = rand()%hwidth;// texture offset
	int ry = rand()%hheight;
	float d = (float)(rand()%1000)/1000.0f-1.5f;//X
	//d = 0;
	int height    = frame->height;
	int width     = frame->width;

	for(int y=0;y<height;++y){ 
		for(int x=0;x<width;++x){
			int index = x*frame->nChannels + y * frame->widthStep;
			unsigned char v = hsv->imageData[index+2];
			if (VFlag){
				float V = v/256.0f;
				V = sqrt(V)*256.0f;
				v = (int)V;
			}

			int X = x + rx;
			int Y = y + ry+(int)(x*d);
			while(Y<0) Y+=hheight*100;
			X %= hwidth;
			Y %= hheight;
			float typeV;

			int maxV = nPattern-1+patternOffset;
			
			typeV = (float)(255-v) / (float)(256/maxV)-patternOffset;
			typeV = maxV-typeV ;

			if (typeV<0) typeV = 0;
			if (typeV>nPattern-1) typeV = nPattern-1;

			float vf = 0.0;
			int a = (int)typeV;
			int b = a+1;
			float w = typeV-a; // weight

			if (hatchingType >= 1){ // Inverse
				a = nPattern-1-a;
				b = nPattern-1-b;
			}
			vf += ((float)(unsigned char)hatching[a]->imageData[X*hatching[a]->nChannels + Y * hatching[a]->widthStep]) * (1.0f-w);
			if (b >=0 && b<=6){
				vf += ((float)(unsigned char)hatching[b]->imageData[X*hatching[b]->nChannels + Y * hatching[b]->widthStep]) * w;

			}

			if (hatchingType <2)
				vf = 255-vf;
			unsigned char vv = hsv->imageData[index+2];
			if (hatchingType ==2){
				//int V = vv;V*=2;if (V>255)V=255;vv = V;// x[X𖾂邭Ă݂
				vv = clip(vv*2,0,255);
				vf=vf*0.7+255.0*0.3; // ̂łƖ邭
			}
			float sf = 1.0;
			if (hatchingType ==3){ // 
				vv = 255;
				sf = 0.0;
				//vf=vf*0.7+255.0*0.3; // ̂łƖ邭
			}
			

			base->imageData[index+0] = hsv->imageData[index+0];
			base->imageData[index+1] = hsv->imageData[index+1]*sf;
			base->imageData[index+2] = (unsigned char)(vv * (float)vf / 255) ;

		}
	}
	cvCvtColor(base,base,CV_HSV2BGR);
	return 1;
}

#if 0
int _tmain( int argc, char** argv )
{
	int id;
	printf("Input device ID = ");scanf("%d",&id);
	CvCapture*	capture = cvCaptureFromCAM( id );
/*
	cvSetCaptureProperty (capture, CV_CAP_PROP_FRAME_WIDTH, 640);
	cvSetCaptureProperty (capture, CV_CAP_PROP_FRAME_HEIGHT, 480);
*/
	if (!capture){
		printf("device open error\n");
		exit(0);
	}

	printf("1/2/3/4... \ސ؂ւ\n");
	printf("5/6    ... hatchingFuncύX\n");
	printf("7/8/9  ... hatchinĝ/Linê/\n");
	printf("f/F    ... FPS\\n");
	printf("ESC    ... I\n");

	IplImage *frame = cvQueryFrame( capture );

	IplImage *res = cvCreateImage (cvGetSize (frame), IPL_DEPTH_8U, 3);
	int width, height;


	width = cvGetSize(frame).width;
	height = cvGetSize(frame).height;
	
	CvFont dfont;
	cvInitFont (&dfont, CV_FONT_HERSHEY_PLAIN  , 1.0f, 1.0f, 0.0f, 1, CV_AA);
	cvNamedWindow( "Hatching", 1 );

	// CLOSE BUTTON@IESC
	HWND hWnd = FindWindow(0,"Hatching");
	HMENU pSysMenu = GetSystemMenu(hWnd,FALSE);
	EnableMenuItem(pSysMenu,SC_CLOSE, MF_GRAYED | MF_BYCOMMAND);


	for(int i=0;i<nPattern;i++){
		char buf[256];
		sprintf(buf,"img/h%d.bmp",i);
		hatching[i] = cvLoadImage(buf);
	}
	DWORD start = timeGetTime();
	int	frameCount = 0;
	char fpsString[64] = " ";
	for(;;)
	{
		int c;

		frame = cvQueryFrame( capture );
		if( !frame ) break;

		if (drawMode & 0x01){
			drawHatching(frame,res);
		}else{
			if (hatchingType>=2){
				cvSet(res,cvScalarAll(255),0);
			}else{
				cvSetZero(res);
			}
		}
		if (drawMode & 0x02){
			drawEdge(frame,res,2);
		}

		// FPS \
		if (drawFps){
			frameCount++;
			DWORD now = timeGetTime();
			if (now-start > 1000){
				float fps = 30000.0f / (now-start);
				sprintf(fpsString,"FPS = %f",fps);
				start = now;
				frameCount = 0;
			}
			cvPutText(res, fpsString, cvPoint(0, height-10), &dfont, CV_RGB(255, 255, 255));
		}

		cvShowImage( "Hatching", res );
		c = cvWaitKey(1);
		if (c==033) break;
		switch(c){
			case '1': hatchingType = 0;DARK=1.0;patternOffset=0;break;
			case '2': hatchingType = 1;DARK=1.0;patternOffset=0;break;
			case '3': hatchingType = 2;DARK=0.7;patternOffset=1;break; // ʔ]Ł@xŗ
			case '4': hatchingType = 3;DARK=0.0;patternOffset=1;break; // 

			case '5': VFlag = 1;break;
			case '6': VFlag = 0;break;
			case '7': drawMode = 0x01;break; // hatching only
			case '8': drawMode = 0x02;break; // line only
			case '9': drawMode = 0x03;break; // both
			case 'f': drawFps  = 1;frameCount = 0;break;
			case 'F': drawFps  = 0;break;
		}
	}
	cvReleaseCapture(&capture);
}

#endif

void InitAnimEffect(char *dllpath) { 
	for(int i=0;i<nPattern;i++){
		char buf[8192];
		sprintf(buf,"%s/img/h%d.bmp", dllpath, i);
		hatching[i] = cvLoadImage(buf);
	}
}


BOOL ExecAnimEffect(FILTER *fp,FILTER_PROC_INFO *fpip) {

	PIXEL_YC *buffer0 = fpip->ycp_edit;
	PIXEL_YC *buffer1 = fpip->ycp_temp;

	int mw = fpip->max_w;
	int mh = fpip->max_h;
	int w = fpip->w;
	int h = fpip->h;

	int hatchingMode = fp->track[0];
	param::X = fp->track[1];
	param::Y = fp->track[2];
	param::Z = fp->track[3];
	lineWidth = fp->track[4];
	lineNoise = fp->track[5];
	VFlag = fp->track[6];
	int lineOn		= fp->check[0];
	int hatchingOn	= fp->check[1];

	switch(hatchingMode){
		case 1: hatchingType = 0;DARK=1.0;patternOffset=0;break;
		case 2: hatchingType = 1;DARK=1.0;patternOffset=0;break;
		case 3: hatchingType = 2;DARK=0.7;patternOffset=1;break; // ʔ]Ł@xŗ
		case 4: hatchingType = 3;DARK=0.0;patternOffset=1;break; // 
	}


	static IplImage *img0 = cvCreateImage(cvSize(w,h), IPL_DEPTH_8U, 3);
	static IplImage *img1 = cvCreateImage(cvSize(w,h), IPL_DEPTH_8U, 3);

	CvSize size = cvGetSize(img0);
	if (size.width != w || size.height != h) {
		cvReleaseImage(&img0);
		cvReleaseImage(&img1);
		img0 = cvCreateImage(cvSize(w,h), IPL_DEPTH_8U, 3);
		img1 = cvCreateImage(cvSize(w,h), IPL_DEPTH_8U, 3);
	}

	CopyBufToCvBGRImg<BYTE>(buffer0, img0, 0,0,w,h, 0,0, mw,mh);

	if (hatchingOn){
		drawHatching(img0, img1);
	}else{
		if (hatchingType>=2){
			cvSet(img1, cvScalarAll(255),0);
		}else{
			cvSetZero(img1);
		}
	}
	if (lineOn){
		drawEdge(img0,img1,2);
	}

	CopyCvBGRImgToBuf<BYTE>(img1, buffer0, 0,0,w,h, 0,0, mw,mh);

	return TRUE;
}